#ifndef VFAT_PROBE_H
#define VFAT_PROBE_H 1

#include <stdint.h>

/* Yucky misaligned values */
struct vfat_super_block {
/* 00*/	unsigned char	vs_ignored[3];
/* 03*/	unsigned char	vs_sysid[8];
/* 0b*/	unsigned char	vs_sector_size[2];
/* 0d*/	uint8_t		vs_cluster_size;
/* 0e*/	uint16_t		vs_reserved;
/* 10*/	uint8_t		vs_fats;
/* 11*/	unsigned char	vs_dir_entries[2];
/* 13*/	unsigned char	vs_sectors[2];
/* 15*/	unsigned char	vs_media;
/* 16*/	uint16_t		vs_fat_length;
/* 18*/	uint16_t		vs_secs_track;
/* 1a*/	uint16_t		vs_heads;
/* 1c*/	uint32_t		vs_hidden;
/* 20*/	uint32_t		vs_total_sect;
/* 24*/	uint32_t		vs_fat32_length;
/* 28*/	uint16_t		vs_flags;
/* 2a*/	uint8_t		vs_version[2];
/* 2c*/	uint32_t		vs_root_cluster;
/* 30*/	uint16_t		vs_insfo_sector;
/* 32*/	uint16_t		vs_backup_boot;
/* 34*/	uint16_t		vs_reserved2[6];
/* 40*/	unsigned char	vs_unknown[3];
/* 43*/	unsigned char	vs_serno[4];
/* 47*/	char		vs_label[11];
/* 52*/	unsigned char   vs_magic[8];
/* 5a*/	unsigned char	vs_dummy2[164];
/*1fe*/	unsigned char	vs_pmagic[2];
};

/* Yucky misaligned values */
struct msdos_super_block {
/* 00*/	unsigned char	ms_ignored[3];
/* 03*/	unsigned char	ms_sysid[8];
/* 0b*/	unsigned char	ms_sector_size[2];
/* 0d*/	uint8_t		ms_cluster_size;
/* 0e*/	uint16_t		ms_reserved;
/* 10*/	uint8_t		ms_fats;
/* 11*/	unsigned char	ms_dir_entries[2];
/* 13*/	unsigned char	ms_sectors[2];
/* 15*/	unsigned char	ms_media;
/* 16*/	uint16_t		ms_fat_length;
/* 18*/	uint16_t		ms_secs_track;
/* 1a*/	uint16_t		ms_heads;
/* 1c*/	uint32_t		ms_hidden;
/* 20*/	uint32_t		ms_total_sect;
/* 24*/	unsigned char	ms_unknown[3];
/* 27*/	unsigned char	ms_serno[4];
/* 2b*/	char		ms_label[11];
/* 36*/	unsigned char   ms_magic[8];
/* 3d*/	unsigned char	ms_dummy2[192];
/*1fe*/	unsigned char	ms_pmagic[2];
};

struct vfat_dir_entry {
	uint8_t	name[11];
	uint8_t	attr;
	uint16_t	time_creat;
	uint16_t	date_creat;
	uint16_t	time_acc;
	uint16_t	date_acc;
	uint16_t	cluster_high;
	uint16_t	time_write;
	uint16_t	date_write;
	uint16_t	cluster_low;
	uint32_t	size;
};

/* maximum number of clusters */
#define FAT12_MAX 0xFF4
#define FAT16_MAX 0xFFF4
#define FAT32_MAX 0x0FFFFFF6

extern int get_vfat_label_uuid(int fd, char **label, char *uuid);

#endif /* VFAT_PROBE_H */
